      //*********************************************************************
      //  Program:   SQLListAPIs
      //  Function:  This service program contains sub procedures for use
      //             in retrieving data from using standard "list" apis and
      //             return that data for use in SQL table functions.
      //*********************************************************************
     h  nomain
      //*********************************************************************
     d deleteUserSpace...
     d                 PR                  EXTPGM('QUSDLTUS')
     D                               20a
     D  errD                               like(ErrorDS)

     d createUserSpace...
     d                 PR                  EXTPGM('QUSCRTUS')
     d  usrSpace                     20a
     d  extAttr                      10a
     d  inzSize                      10i 0
     d  intVal                        1a
     d  pubAuth                      10a
     d  descTxt                      50a
     d  rplc                         10a
     d  errorD                             like(ErrorDS)

     d retrieveUserSpaceHeader...
     d                 PR                  EXTPGM('QUSRTVUS')
     d usrSpace                      20a
     D ofStart                       10i 0
     D ofLen                         10i 0
     d  hdrSect                            like(headerDS)
     d  errorD                             like(ErrorDS)

     d retrieveUserSpaceSPL0300...
     d                 PR                  EXTPGM('QUSRTVUS')
     d usrSpace                      20a
     D ofStart                       10i 0
     D ofLen                         10i 0
     d  splf3                              like(splf0300)
     d  errorD                             like(ErrorDS)

      //***************************************************
      // Output format for API QUSLSPL - Format SPLF0300
      //***************************************************
     D SPLF0300        DS
     D  SJobName                     10a
     D  SUserName                    10a
     D  SJob#                         6a
     D  SSplfName                    10a
     D  SSplfNum                     10i 0
     D  SSplfStat                    10i 0
     D  DateOpned                     7a
     D  TimeOpned                     6a
     D  SplfSched                     1a
     D  SplfSysNam                   10a
     D  UsrSpcfDta                   10a
     D  SFormType                    10a
     D  SOutq                        10a
     D  SOutqLib                     10a
     D  SAuxStg                      10i 0
     D  SplfSiz                      10i 0
     D  SplfSzMlt                    10i 0
     D  SPages                       10i 0
     D  SCopies                      10i 0
     D  SPriority                     1a
     D  SRsvrd                        3a
     D  SIPPID                       10i 0
     d retrieveSpooledFileList...
     d                 PR                  EXTPGM('QUSLSPL')
     d  usrSpace                     20a
     d  Format                        8a
     d  User                         10a
     d  IOutq                        20a
     d  IFrmTyp                      10a
     d  IUsrDta                      10a
     d  errorD                             like(ErrorDS)

      //*************************************************************************
      // User Space Variables
      //*************************************************************************
     D descTxt         S             50a
     D extAttr         S             10a    INZ('*JOB')
     D inzSize         S             10i 0  INZ(5000)
     D intlVal         S              1a    INZ(X'00')
     D pubAuth         S             10a    INZ('*ALL')
     D rplc            S             10a    INZ('*YES')
      //
      //*************************************************************************
      // List Data Generic Header
      //*************************************************************************
     D headerDS        Ds
     D  UserArea                     64
     D  GenHdrSiz                    10i 0
     D  StrucLevel                    4
     D  FormatName                    8
     D  ApiUsed                      10
     D  CreateStamp                  13
     D  InfoStatus                    1
     D  SizeUsUsed                   10i 0
     D  InpParmOff                   10i 0
     D  InpParmSiz                   10i 0
     D  HeadOffset                   10i 0
     D  HeaderSize                   10i 0
     D  ListOffset                   10i 0
     D  ListSize                     10i 0
     D  ListNumber                   10i 0
     D  EntrySize                    10i 0
     d  User           s             10a
     d  Outq           s             20a
     d  FormType       s             10a
     d  UserData       s             10a
     d SQL_OK          c                   '00000'
     d SQL_EOF         c                   '02000'
     d SQL_FILE_NOT_FOUND...
     d                 c                   '00204'
     d ErrorDS         ds                  Qualified
     d BytesReturned                 10i 0 Inz(%Size(ErrorDS))
     d BytesAvailable                10i 0
     d MsgID                          7a
     d                                1a
     d MsgText                      512a
      //*********************************************************************
      //  Procedure: getMessages
      //  Function:  Retrieve message descriptions for all messages in a
      //             given message file.  Data is returned as an SQL table
      //             function.
      //*********************************************************************
     d getMessages     pr
      * Input Parameters
     d   inLibrary                   10a   Const varying
     d   inMsgF                      10a   Const varying
      * Output Parameters
     d   outMsgId                     7a
     d   outMsgSev                    2  0
     d   outMsgDesc                 500a   varying
     d   outMsgHelp                 500a   varying
      * NULL Indicators
     d   niLibr                       5i 0
     d   niMsgf                       5i 0
     d   niMsgId                      5i 0
     d   niMsgSev                     5i 0
     d   niMsgDesc                    5i 0
     d   niMsgHelp                    5i 0
      * SQL Info
     d   SQLState                     5
     d   FunctName                  517a   varying
     d   SpecName                   128a   varying
     d   SQLMsg                      70a   varying
     d   CallType                    10I 0
      //*********************************************************************
      //  Procedure: getSpooledFileList
      //  Function:  Retrieve a list of spooled files based on supplied
      //             criteria.  Data is returned as an SQL table function.
      //*********************************************************************
     d getSpooledFileList...
     d                 pr
      * Input Parameters
     D  inpUserId                    10a   varying
     D  inpOutQueue                  20a   varying
     D  inpFormType                  10a   varying
     D  inpUserData                  10a   varying
      * Output Parameters
     d  outSplfNam                   10a
     d  outSplfnum                   10i 0
     d  outSplfSts                   10a
     d  outFrmTyp                    10a
     d  outOutq                      10a
     d  outPages                     10i 0
     d  outCopies                    10i 0
     d  outJobNam                    10a
     d  outUserNam                   10a
     d  outJob#                       6a
      * NULL Indicators
     d   niUserId                     5i 0
     d   niOutQueue                   5i 0
     d   niFormType                   5i 0
     d   niUserData                   5i 0
     d   niSplfNam                    5i 0
     d   niSplfnum                    5i 0
     d   niSplfSts                    5i 0
     d   niFrmTyp                     5i 0
     d   niOutq                       5i 0
     d   niPages                      5i 0
     d   niCopies                     5i 0
     d   niJobNam                     5i 0
     d   niUserNam                    5i 0
     d   niJob#                       5i 0
      * SQL Info
     d   SQLState                     5
     d   FunctName                  517a   varying
     d   SpecName                   128a   varying
     d   SQLMsg                      70a   varying
     d   CallType                    10I 0
      //*********************************************************************
      //  Procedure: getMessages
      //  Function:  Retrieve message descriptions for all messages in a
      //             given message file.  Data is returned as an SQL table
      //             function.
      //*********************************************************************
     p getMessages     b                   EXPORT
     d getMessages     pi
      * Input Parameters
     d   inLibrary                   10a   Const varying
     d   inMsgF                      10a   Const varying
      * Output Parameters
     d   outMsgId                     7a
     d   outMsgSev                    2  0
     d   outMsgDesc                 500a   varying
     d   outMsgHelp                 500a   varying
      * NULL Indicators
     d   niLibr                       5i 0
     d   niMsgf                       5i 0
     d   niMsgId                      5i 0
     d   niMsgSev                     5i 0
     d   niMsgDesc                    5i 0
     d   niMsgHelp                    5i 0
      * SQL Info
     d   SQLState                     5
     d   FunctName                  517a   varying
     d   SpecName                   128a   varying
     d   SQLMsg                      70a   varying
     d   CallType                    10I 0
     dRetrieveMsg      pr                  ExtPgm('QMHRTVM')
     d MsgInfo                    32767a   Options(*varsize)
     d RtnLength                     10i 0 Const
     d RtnFormat                      8a   Const
     d MsgID                          7a   Const
     d QualMsgF                      20a   Const
     d RplData                    32767a   Options(*varsize) Const
     d RplDataLen                    10i 0 Const
     d RplSubValue                   10a   Const
     d RtnCtlChar                    10a   Const
     d ErrorCode                    500a
     d RtvOption                     10a   Const
     d CCSIDCnvTo                    10i 0 Const Options(*Omit)
     d CCSIDRplDta                   10i 0 Const Options(*Omit)

     dRTVM0300         ds                  Qualified
     d BytesReturned                 10i 0
     d BytesAvailable                10i 0
     d MsgSev                        10i 0
     d AlertIndex                    10i 0
     d AlertOption                    9a
     d LogPrb                         1a
     d MsgID                          7a
     d                                3a
     d NbrSubValueFormat...
     d                               10i 0
     d CCSIDConvStsText...
     d                               10i 0
     d CCSIDConvRplDta...
     d                               10i 0
     d CCSIDRtnText                  10i 0
     d OffsetDftRpy                  10i 0
     d DftRpyRtnLen                  10i 0
     d DftRpyAvlLen                  10i 0
     d OffsetMsg                     10i 0
     d MsgLenRtn                     10i 0
     d MsgLenAvl                     10i 0
     d OffsetMsgHlp                  10i 0
     d MsgHlpRtnLen                  10i 0
     d MsgHlpAvlLen                  10i 0
     d OffsetSubVar...
     d                               10i 0
     d SubVarRtnLen...
     d                               10i 0
     d SubVarAvlLen...
     d                               10i 0
     d SubVarElement...
     d                               10i 0
     d                              500a   Varying
     d DftRpy                       500a   Varying
     d Msg                          500a   Varying
     d MsgHlp                       500a   Varying
     d SubVar                       500a   Varying

     d SQL_OK          c                   '00000'
     d SQL_EOF         c                   '02000'
     d SQL_FILE_NOT_FOUND...
     d                 c                   '00204'
     d ErrorDS         ds                  Qualified
     d BytesReturned                 10i 0 Inz(%Size(ErrorDS))
     d BytesAvailable                10i 0
     d MsgID                          7a
     d                                1a
     d MsgText                      512a

     d MsgID           s              7a
     d LogPrb          s              4a
     d msgRtv          s             10a   STATIC
     d lastMsg         s              7a   STATIC

      /free
          SQLState = SQL_OK;
          if calltype = -1;
            if niLibr = 1 OR niMsgf = 1;
              SQLState=SQL_FILE_NOT_FOUND;
              msgRtv = '';
              *INLR = *ON;
              Return;
            ENDIF;
            lastMsg = '';
            msgRtv = '*FIRST';
          else;
            msgRtv = '*NEXT';
          ENDIF;
          RetrieveMsg( RTVM0300
                     : %Len(RTVM0300)
                     : 'RTVM0300'
                     : LastMsg
                     : inMsgF  + inLibrary
                     : ' '
                     : 1
                     : '*NO'
                     : '*NO'
                     : ErrorDS
                     : msgRtv
                     : 0
                     : 0 );
          If ErrorDS.BytesAvailable <> 0;
              exsr setEOF;
          Else;
            If RTVM0300.MsgID <> '';
              outMsgId = RTVM0300.MsgId;
              outMsgSev = RTVM0300.MsgSev;
              outMsgDesc = %subst( RTVM0300
                                 : RTVM0300.OffsetMsg+1
                                 : RTVM0300.MsgLenRtn);
              outMsgHelp = %subst( RTVM0300
                                 : RTVM0300.OffsetMsgHlp+1
                                 : RTVM0300.MsgHlpRtnLen);
              lastMsg = outMsgId;
            else;
              exsr setEOF;
            EndIf;
          EndIf;
          Return;

          Begsr setEOF;
            outMsgId = '';
            outMsgSev = 0;
            outMsgDesc = '';
            outMsgHelp = '';
            SQLState = SQL_EOF;
            msgRtv = '';
            *InLR = *On;
            niMsgID = 1;
            niMsgID = 1;
            niMsgID = 1;
            niMsgID = 1;
            lastMsg = '';
          ENDSR;
      /end-free
     p getMessages     e

      //*********************************************************************
      //  Procedure: getSpooledFileList
      //  Function:  Retrieve spooled file list entries based on specified
      //             input parameters.  Data is returned as an SQL table
      //             function.
      //*********************************************************************
     p getSpooledFileList...
     p                 b                   export
     d getSpooledFileList...
     d                 pi
      * Input Parameters
     D  inpUserId                    10a   varying
     D  inpOutQueue                  20a   varying
     D  inpFormType                  10a   varying
     D  inpUserData                  10a   varying
      * Output Parameters
     d  outSplfNam                   10a
     d  outSplfnum                   10i 0
     d  outSplfSts                   10a
     d  outFrmTyp                    10a
     d  outOutq                      10a
     d  outPages                     10i 0
     d  outCopies                    10i 0
     d  outJobNam                    10a
     d  outUserNam                   10a
     d  outJob#                       6a
      * NULL Indicators
     d   niUserId                     5i 0
     d   niOutQueue                   5i 0
     d   niFormType                   5i 0
     d   niUserData                   5i 0
     d   niSplfNam                    5i 0
     d   niSplfnum                    5i 0
     d   niSplfSts                    5i 0
     d   niFrmTyp                     5i 0
     d   niOutq                       5i 0
     d   niPages                      5i 0
     d   niCopies                     5i 0
     d   niJobNam                     5i 0
     d   niUserNam                    5i 0
     d   niJob#                       5i 0
      * SQL Info
     d   SQLState                     5
     d   FunctName                  517a   varying
     d   SpecName                   128a   varying
     d   SQLMsg                      70a   varying
     d   CallType                    10I 0
      //***************************************************************
      // Miscellaneous Variables
      //***************************************************************
     D RRn1            S              5  0
     D Spl#            S              6a

      //***************************************
      // Input format for API QUSLSPL
      //**************************************
     D outFormat       S              8a

     D usrSpace        S             20a   static
     D listID          S             10i 0 static inz(0)
     D ofStart         S             10i 0  static
     D ofLen           S             10i 0  static

      /FREE
         if calltype = -1;
           *INLR = *OFF;
           usrSpace= 'SPLFLIST  QTEMP     ';
           descTxt = 'SPLF List User Space';
           extAttr = ' ';
           inzSize = 5000;
           intlVal  = ' ';
           pubAuth = '*CHANGE';
           outFormat = 'SPLF0300';
           deleteUserSpace( usrSpace
                          : errorDS);
           createUserSpace( usrSpace
                         : extAttr
                         : inzSize
                         : intlVal
                         : pubAuth
                         : descTxt
                         : rplc
                         : errorDS);
           if ErrorDS.BytesAvailable = 0;
             User = inpUserID;
             OutQ = inpOutQueue;
             FormType = inpFormType;
             UserData = inpUserData;
             retrieveSpooledFileList( usrSpace
                                    : outFormat
                                    : User
                                    : OutQ
                                    : FormType
                                    : UserData
                                    : errorDS
                                     );
             ofStart = 1;
             ofLen = 140;
              retrieveUserSpaceHeader( usrSpace
                                     : ofStart
                                     : ofLen
                                     : headerDS
                                     : errorDS);
             if ErrorDS.BytesAvailable <> 0;
               exsr setEOF;
               return;
             endif;
             ofStart = headerDS.ListOffset + 1;
           else;
              exsr setEOF;
              return;
           endif;
         endif;
        if niUserId   = 1 OR
           niOutQueue = 1 OR
           niFormType = 1 OR
           niUserData = 1;
           SQLState=SQL_FILE_NOT_FOUND;
           usrSpace = '';
           *INLR = *ON;
           Return;
         ENDIF;
         if calltype <= 0;
                if listId < headerDS.ListNumber;
                  listid += 1;
                  clear Splf0300;
                  retrieveUserSpaceSpl0300( usrSpace
                                         : ofStart
                                         : ofLen
                                         : Splf0300
                                         : errorDS);

                 if ErrorDS.BytesAvailable = 0 and SSplfName <> '';
                    Select;
                    When SSplfStat = 1;
                      outSplfsts = 'READY';
                    When SSplfStat = 2;
                      outSplfsts = 'OPENED';
                    When SSplfStat = 3;
                      outSplfsts = 'CLOSED';
                    When SSplfStat = 4;
                      outSplfsts = 'SAVED';
                    When SSplfStat = 5;
                      outSplfsts = 'WRITING';
                    When SSplfStat = 6;
                      outSplfsts = 'ON HOLD';
                    When SSplfStat = 7 or SSplfStat = 8;
                      outSplfsts = 'PENDING';
                    When SSplfStat = 10;
                      outSplfsts = 'FINISHED';
                    When SSplfStat = 11;
                      outSplfsts = 'SENDING';
                    When SSplfStat = 12;
                      outSplfsts = 'DEFERRED';
                    Endsl;
                    outSplfNam = SSplfName;
                    outSplfnum = SSplfNum;
                    outFrmTyp = SFormType;
                    outOutq = Soutq;
                    outPages = SPages;
                    outCopies = SCopies;
                    outJobNam =  SJObName;
                    outUserNam = SUserName;
                    outJob#    = SJob#;
                    SQLState = SQL_OK;
                  else;
                    exsr setEOF;
                    Return;
                  endif;
                  ofStart = ofStart + headerDS.EntrySize;
             else;
               exsr setEOF;
               Return;
             Endif;
           Endif;
           Return;
           Begsr setEOF;
             outSplfNam = '';
             outSplfnum = 0;
             outFrmTyp  = '';
             outOutq =  '';
             outPages = 0;
             outCopies  = 0;
             outJobNam  = '';
             outUserNam = '';
             outJob#    = '';
             SQLMsg  = '';
             SQLState = SQL_EOF;
             listId = 0;
             *InLR = *On;
             niSplfNam = 1;
             niSplfnum = 1;
             niFrmTyp = 1;
             niOutq = 1;
             niPages = 1;
             niCopies = 1;
             niJobNam = 1;
             niUserNam = 1;
             niJob# = 1;
          ENDSR;
      /END-FREE
     p getSpooledFileList...
     p                 e 